
#include <ESP8266WiFi.h>
#include <WiFiClientSecure.h>
#include <UniversalTelegramBot.h>
#include <DHT.h>
#define DHTPIN 4
#define DHTTYPE DHT11
DHT dht(DHTPIN, DHTTYPE);


char ssid[] = "SSID KAMU";     // your network SSID (name)
char password[] = "PASSWORDNYA"; // your network key


#define BOTtoken "493614521:AAH7HlmTj53_ym3yc70qMytrUo-4inh3qBQ"  // your Bot Token (Get from Botfather)

WiFiClientSecure client;
UniversalTelegramBot bot(BOTtoken, client);
int led1=14;
int led2=13;
int relay=5;
int buzzer=12;
float h=0;
float t=0;
int val=0;
int Bot_mtbs = 1000; //mean time between scan messages
long Bot_lasttime;   //last time messages' scan has been done
bool Start = false;

void handleNewMessages(int numNewMessages) {
  Serial.println("handleNewMessages");
  Serial.println(String(numNewMessages));

  for (int i=0; i<numNewMessages; i++) {
    String chat_id = String(bot.messages[i].chat_id);
    String text = bot.messages[i].text;

    String from_name = bot.messages[i].from_name;
    if (from_name == "") from_name = "Guest";

    if (text == "/on") {
      bot.sendChatAction(chat_id, "typing");
      String welcome = "Relay dinyalakan";
      digitalWrite(buzzer,HIGH);
      delay(50);
      digitalWrite(buzzer,LOW);
      delay(50);
      digitalWrite(buzzer,HIGH);
      delay(50);
      digitalWrite(buzzer,LOW);
      digitalWrite(relay,HIGH);
      bot.sendMessage(chat_id, welcome);
    }
    if (text == "/off") {
      bot.sendChatAction(chat_id, "typing");
      String welcome = "Relay dimatikan";
      digitalWrite(buzzer,HIGH);
      delay(50);
      digitalWrite(buzzer,LOW);
      delay(50);
      digitalWrite(buzzer,HIGH);
      delay(50);
      digitalWrite(buzzer,LOW);
       delay(50);
      digitalWrite(buzzer,HIGH);
      delay(50);
      digitalWrite(buzzer,LOW);
      digitalWrite(relay,LOW);
      bot.sendMessage(chat_id, welcome);
    }
    if (text == "/sensor") {
        val = analogRead(0);
        Serial.println(val);
      bot.sendChatAction(chat_id, "typing");
      digitalWrite(buzzer,HIGH);
      delay(50);
      digitalWrite(buzzer,LOW);
      awal:
        
   h = dht.readHumidity();
   t = dht.readTemperature();
  if (isnan(h) || isnan(t)) {
    Serial.println("Failed to read from DHT sensor!");
    delay(10);
    goto awal;
  }
val= map(val,350,235,0,100);
if(val<0)val=0;
else if (val>100)val=100;
      String welcome = "Data sensor untuk " + from_name + ".\nSoil moisture: ";
      welcome += val;
      welcome += "%.\nSuhu ";
      welcome += t;
      welcome += "C.\nKelembaban ";
      welcome += h;
      welcome += "%.\nRelay dalam kondisi ";
      boolean a=digitalRead(relay);
      if(a)welcome += "menyala.";
      else welcome += "mati.";
      bot.sendMessage(chat_id, welcome);
    }
  }
}


void setup() {
  Serial.begin(115200);
  
  dht.begin();
  // Set WiFi to station mode and disconnect from an AP if it was Previously
  // connected
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(100);
  pinMode(buzzer,OUTPUT);
  pinMode(relay,OUTPUT);
  pinMode(led1,OUTPUT);
  pinMode(led2,OUTPUT);
  Serial.print("Connecting Wifi: ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    digitalWrite(led1,HIGH);
    delay(500);
  }

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
  digitalWrite(led1,LOW);
}

void loop() {
if (WiFi.status() != WL_CONNECTED) {
    delay(1);
    digitalWrite(led1,HIGH);
    WiFi.begin(ssid, password);
    return;
}
digitalWrite(led1,LOW);
  if (millis() > Bot_lasttime + Bot_mtbs)  {
    int numNewMessages = bot.getUpdates(bot.last_message_received + 1);
    digitalWrite(led2,HIGH);
    delay(10);
    digitalWrite(led2,LOW);
    while(numNewMessages) {
      Serial.println("got response");
      handleNewMessages(numNewMessages);
      numNewMessages = bot.getUpdates(bot.last_message_received + 1);
    }

    Bot_lasttime = millis();
  }
  
}
